#FreTS 
Frequency-domain MLPs are More Effective Learners in Time Series Forecasting

###Models
- FreTS: our model including frequency channel and temporal learners
- DLinearF: this model is used for ablation study (DLinear part) by replacing the corresponding MLP with our FreMLP
- NLinearF: this model is used for ablation study (NLinear part) by replacing the corresponding MLP with our FreMLP
- CLinear: this model is used for the visualization of global view
- ELinear: this model is used for the visualization of energy compaction

###Datasets
In the data directory, we put only ETT, Electricity, Exchange, Weather, Traffic, ECG, METR-LA, and COVID-19 datasets due to limitations on upload file size.
The datasets can be downloaded from the websites as follows:
1. Solar: https://www.nrel.gov/grid/solar-power-data.html
2. Wiki: https://www.kaggle.com/c/web-traffic-time-series-forecasting/data
3. ETT: https://github.com/zhouhaoyi/ETDataset
4. Weather: https://www.bgc-jena.mpg.de/wetter
5. Exchange: https://github.com/laiguokun/multivariate-time-series-data
6. METR-LA: https://github.com/liyaguang/DCRNN
7. COVID-19: https://github.com/CSSEGISandData/COVID-19
8. Electricity: https://archive.ics.uci.edu/ml/datasets/ElectricityLoadDiagrams20112014
9. ECG: http://www.timeseriesclassification.com/description.php?Dataset=ECG5000
10. Traffic: https://archive.ics.uci.edu/ml/datasets/PEMS-SF

Details can be seen in Appendix B.1
###Baselines
####short-term
1. DeepGLO: https://github.com/rajatsen91/deepglo
2. LSTNet: https://github.com/laiguokun/LSTNet
3. TCN: https://github.com/locuslab/TCN
4. SFM: https://github.com/z331565360/State-Frequency-Memory-stock-prediction
5. StemGNN: https://github.com/microsoft/StemGNN
6. MTGNN: https://github.com/nnzhan/MTGNN
7. GraphWaveNet:https://github.com/nnzhan/Graph-WaveNet
8. AGCRN: https://github.com/LeiBAI/AGCRN
9. TAMP-S2GCNets: https://www.dropbox.com/sh/n0ajd5l0tdeyb80/AABGn-ejfV1YtRwjf_L0AOsNa?dl=0
10. DCRNN:https://github.com/liyaguang/DCRNN
11. STGCN: https://github.com/VeritasYin/STGCN_IJCAI-18
12. Informer: https://github.com/zhouhaoyi/Informer2020
13. Reformer: https://github.com/thuml/Autoformer
14. Autoformer: https://github.com/thuml/Autoformer
15. FEDformer: https://github.com/MAZiqing/FEDformer
####long-term    
12. Informer: https://github.com/zhouhaoyi/Informer2020
13. Reformer: https://github.com/thuml/Autoformer
14. Autoformer: https://github.com/thuml/Autoformer
15. FEDformer: https://github.com/MAZiqing/FEDformer
16. LTSF-Linear: https://github.com/cure-lab/LTSF-Linear
17. PatchTST: https://github.com/PatchTST

Details can be seen in Appendix B.2


### Running the code
- forecasting

`python run_longExp.py`

- draw the visualization

`python weight_plot.py`

put the corresponding checkpoint file into the test directory, and select the corresponding weights (e.g., w) to visualize
